#!/usr/bin/env bash
# set the version to use the library
min_ver=22
# verify before executing this that you have the proper targets installed
cargo ndk -t armeabi-v7a -t arm64-v8a -t x86_64 -t x86 -p ${min_ver} build --release 

# moving libraries to the android project
jniLibs=./android/rusty-android-lib/src/main/jniLibs
libName=librustwallet.a

rm -rf ${jniLibs}

# mkdir ${jniLibs}
# mkdir ${jniLibs}/arm64-v8a
# mkdir ${jniLibs}/armeabi-v7a
# mkdir ${jniLibs}/x86_64
# mkdir ${jniLibs}/x86

targetBase=~/Documents/workspace/crypto/cocos_js/external/android

cp target/aarch64-linux-android/release/${libName} ${targetBase}/arm64-v8a/${libName}
cp target/armv7-linux-androideabi/release/${libName} ${targetBase}/armeabi-v7a/${libName}
cp target/x86_64-linux-android/release/${libName} ${targetBase}/x86_64/${libName}
cp target/i686-linux-android/release/${libName} ${targetBase}/x86/${libName}
cbindgen src/lib.rs -l c > rustwallet.h
cp rustwallet.h ${targetBase}/arm64-v8a/include/rustwallet/rustwallet.h
cp rustwallet.h ${targetBase}/armeabi-v7a/include/rustwallet/rustwallet.h
cp rustwallet.h ${targetBase}/x86_64/include/rustwallet/rustwallet.h
cp rustwallet.h ${targetBase}/x86/include/rustwallet/rustwallet.h