use base64::{engine::general_purpose, Engine as _};

pub fn hex_to_base64(content: &str) -> String {
    let str_tmp = match hex::decode(content) {
        Ok(v) => v,
        Err(e) => panic!("error decode hex str: {}", e),
    };
    general_purpose::STANDARD_NO_PAD.encode(&str_tmp)
}

pub fn base64_to_hex(content: &str) -> String {
    let str_tmp = match general_purpose::STANDARD_NO_PAD.decode(content) {
        Ok(v) => v,
        Err(e) => panic!("error decode base64 str: {}", e),
    };
    hex::encode(&str_tmp)
}
